#				SSBA 1.22F
#
# Makefile : dhry.mk
#
##############################################################################
SHELL=/bin/sh

.PRECIOUS:	run
.IGNORE:	

PRINTER	=	lp
PRINTOPT=	-l66
PAGER	=	more
COMPILER=	cc
LOCALOPT=	-O
FLOPT=		


CFLAGS	=	
REGISTER=	-DREG=register

CC	=	$(COMPILER) $(CFLAGS)
CCO	=	$(COMPILER) $(CFLAGS) $(LOCALOPT)

NAME	=	dhry
README	=	${NAME}.doc ${NAME}.files
MAKEFILE=	${NAME}.mk
CONFIG  =	${NAME}.cf
RUN     =	${NAME}.run
DATAS	=	${NAME}.dat
LOG	=	${NAME}.log
RES	=	${NAME}.res
JOU	=	${NAME}.jou
KILL	=	${NAME}.kill
TAR	=	${NAME}.tar
SHAR	=	${NAME}.shar
BANNER	=	${NAME}.ban
HEADERS	=	${NAME}.h
SOURCES	=	${NAME}nr.c ${NAME}r.c ${NAME}nro.c ${NAME}ro.c
OBJECTS	=	${NAME}nr.o ${NAME}r.o ${NAME}nro.o ${NAME}ro.o
SSBALOG	=	../results/ssba.log
SSBASIZE=	../results/ssba.size
TRACE	=	1>>$(JOU) 2>&1
NUL	=	1>/dev/null 2>&1
SCRIPTS =	$(MAKEFILE) $(CONFIG) $(RUN)
TARGETS	=	${NAME}nr ${NAME}r ${NAME}nro ${NAME}ro
ARCHIVES=	$(TAR) $(SHAR)
VOLATILE=	$(JOU) $(LOG) $(RES) $(KILL) $(HEADERS) $(OBJECTS)\
		$(TARGETS) $(ARCHIVES) core
FILES	=	$(BANNER) $(README) $(SCRIPTS) $(DATAS) $(SOURCES)

conf:
		@chmod u+x $(CONFIG)
		@./$(CONFIG)

compile:	$(TARGETS)

run:
		@./$(RUN)
sizes:
		@ls -l $(TARGETS) | tee -a $(SSBASIZE)
clean:
		@rm -f $(VOLATILE) $(NUL)
readme:
		@$(PAGER) $(README)
print:
		@pr $(PRINTOPT) -h $(NAME) $(SCRIPTS) | $(PRINTER)
printall:
		@pr $(PRINTOPT) -h $(NAME) $(FILES) | $(PRINTER)
tar:
		@tar cf $(TAR) $(FILES)
shar:
		@shar $(FILES) > $(SHAR)
force:

$(BANNER):
		@banner $(NAME) >$@

${NAME}nr:	${NAME}nr.c $(HEADERS)
		$(CC) ${NAME}nr.c -o $@			$(TRACE)
${NAME}r:	${NAME}r.c $(HEADERS)
		$(CC) $(REGISTER) ${NAME}r.c -o $@	$(TRACE)
${NAME}nro:	${NAME}nro.c $(HEADERS)
		$(CCO) ${NAME}nro.c -o $@		$(TRACE)
${NAME}ro:	${NAME}ro.c $(HEADERS)
		$(CCO) $(REGISTER) ${NAME}ro.c -o $@	$(TRACE)
$(HEADERS):	$(DATAS) ../install/hz.h
		@./$(CONFIG)
