#! /bin/sh
#				SSBA 1.22F
# 
# Script : unix.sh
# 
RES=../results/ssba.res
SYN=../results/synthese
unix=""
define=""
if [ -f /usr/include/sys/signal.h ] ; then
	SIGNAL=/usr/include/sys/signal.h
	signal="#include <sys/signal.h>"
else
	SIGNAL=/usr/include/signal.h
	signal="#include <signal.h>"
fi
bsd=0
if [ -f /vmunix ] ; then
	bsd=1
	unix=$unix"BSD"
	define=$define"-DVMUNIX "
	if [ `grep -c BSD4_3 /usr/include/sys/param.h` != 0 ] ; then
		unix=$unix"4.3 "
		define=$define"-DBSD4v3 -DBSD4v2 "
	elif [ `grep -c SIGVTALRM $SIGNAL` != 0 ] ; then
		unix=$unix"4.2 "
		define=$define"-DBSD4v2 "
	else
		unix=$unix"4.1 "
		define=$define"-DBSD4v1 "
	fi
elif [ -f /mach ] ; then
	bsd=1
	unix=$unix"MACH "
	define=$define"-DVMUNIX -DBSD4v3 "
elif [ -f /bsd4.3 ] ; then
	bsd=1
	unix=$unix"Apollo BSD4.3 "
	define=$define"-DVMUNIX -DBSD4v3 "
elif [ -f /bsd4.2 ] ; then
	bsd=1
	unix=$unix"Apollo BSD4.2 "
	define=$define"-DVMUNIX -DBSD4v2 "
elif [ -f /sys5.3 ] ; then
	bsd=0
	unix=$unix"Apollo SVR3 "
	define=$define"-DSysV "
elif [ -f /sys5.2 ] ; then
	bsd=0
	unix=$unix"Apollo SVR2 "
	define=$define"-DSysV "
elif [ -f /xenix ] ; then
	bsd=0
	unix=$unix"Xenix "
	define=$define"-DM_XENIX "
elif [ -d /vrm ] ; then
	bsd=0
	unix=$unix"AIX "
elif [ -f /hp-ux ] ; then
	bsd=0
	unix=$unix"hp-ux "
fi
if [ -r /bin/universe ] ; then
	unix=$unix"Universe "
fi
if [ -f /usr/include/termio.h -o -f /usr/include/sys/termio.h ] ; then
	if [ $bsd = 0 ] ; then
		define=$define"-DTERMIO "
	fi
fi
if [ -f /usr/include/sys/ipc.h ] ; then
	unix=$unix"SV"
	if [ $bsd = 0 ] ; then
		define=$define"-DSysV "
	fi
	if [ -f /stand/unix ] ; then
		unix=$unix"R4 "
	elif [ `grep -c SIGPOL $SIGNAL` != 0 ] ; then
		unix=$unix"R3 "
	elif [ `grep -c LOBLK /usr/include/sys/termio.h` != 0 ] ; then
		unix=$unix"R2 "
	else
		unix=$unix"R1 "
	fi
elif [ `grep -c SIGUSR2 $SIGNAL` != 0 ] ; then
	unix=$unix"sys3"
	if [ $bsd = 0 ] ; then
		define=$define"-DSysV "
	fi
elif [ `grep -c SIGUSR $SIGNAL` = 0 ] ; then
	if [ `grep -c SIGTERM $SIGNAL` != 0 ] ; then
		unix=$unix"V7"
		define=$define"-DV7 "
	else
		unix=$unix"unknown"
		define=$define"-DUNIXLIKE "
	fi
fi
echo $unix >../install/system
echo "unix = $unix" >> $RES
echo "unix = $unix" >> $SYN
echo $define >../install/define
echo "define = $define" >> $RES
echo "define = $define" >> $SYN
echo $signal >../install/signal.h
echo "signal = $signal" >> $RES
