#!/bin/sh
#
# ssba.awk
#
# mise en forme d'une fiche de synthese brute
# au format tbl | troff -mm
#
# Philippe Dax	Copyright (C) 1989
#
if test $# = 0
then
	echo "Usage: $0 machine"
	echo "Hints: mv synthese machine.syn"
	exit 1
fi
if [ ! -f $1.syn ]; then
	echo "You must move \"synthese\" towards \"machine_name.syn\""
	if [ -f synthese ]; then
		echo "But I make it for you with \"synthese.syn\""
		cp synthese synthese.syn
		SYN=synthese.syn
	else
		echo "Hints: mv synthese machine.syn"
		exit 1
	fi
else
	SYN=$1.syn
fi
sed -e 's/ I /\
/g' -e 's/=/ = /g' -e 's/	/ /g' -e 's/):/): /g' $SYN | \
awk '
BEGIN		{
	printf(".ds RU RESULTATS SSBA\n")
	printf(".so macros/tribu.mm\n")
	printf(".PA 1\n")
	printf(".S 9 10\n")
}
/SYNTHESE/	{
	printf(".TS\ncenter doublebox, tab(#);\ncB s\ncB s\ncB s\nl | l.\n")
	printf(".sp .5\n\\f(HB")
	printf("%s %s %s %s %s %s %s %s#\n",$1,$2,$3,$4,$5,$6,$7,$8)
	printf(".sp .2\n=\n.sp .2\n")
}
/DEBUT/		{
	datedebut = $10 " " $11 " " $12 " " $13 " " $14 " " $15 " " $16
	printf("ENVIRONNEMENT#\n_\n")
}
/^Identification/		{
	printf("%s\\fP#\n_\n", $0)
}
/^unix/		{
	printf("Type d'\''Unix# %s %s\n", $3, $4)
}
/^Commande C/	{
	commandec = $4 " " $5 " " $6 " " $7
}
/^Commande F/	{
	commandef = $4 " " $5 " " $6 " " $7
}
/^define/	{
	commandec = commandec " " $3 " " $4
	commandef = commandef " " $3 " " $4
	printf("Commande C# %s\n", commandec)
	printf("Commande F# %s\n", commandef)
}
/lancement/	{
	procs = $16
}
/^machine/	{
	print "Nom du site#", $3
}
/^whoami/	{
	print "Nom de login du benchmarqueur#", $3
}
/^valeur du/	{
	print "Valeur du HZ#", $5
}
/restant/	{
	printf("Nombre de processus avant le lancement# %d\n", procs)
	print "Nombre de processus restant pour l'\''ex{cution#", $8
}
/^Espace/	{
	print "Espace m{moire virtuelle disponible#", $7/1000, "Mo"
}
/^Unexpected/	{
	print "Espace m{moire virtuelle disponible#Unexepected under/overflow"
}
/^mips/		{
	printf("_\n.T&\ncB s.\n")
	printf("RESULTATS#\n_\n")
	printf(".T&\nl | l.\n")
	printf("Date de d{but# %s\n", datedebut)
	print "Mips/Joy#", $2
}
/^dhrynr\(/	{ print "Dhrystone (sans registres,sans optimisation)#", $5, "Dhry/s" }
/^dhryr\(/	{ print "Dhrystone (avec registres,sans optimisation)#", $5, "Dhry/s" }
/^dhrynro/	{ print "Dhrystone (sans registres,avec optimisation)#", $5, "Dhry/s" }
/^dhryro/	{ print "Dhrystone (avec registres,avec optimisation)#", $5, "Dhry/s" }
/^whets/	{ print "Whetstone (simple pr{cision)#", $5, "KWhet/s" }
/^whetd/	{ print "Whetstone (double pr{cision)#", $5, "KWhet/s" }
/^linpackrs/	{ print "Linpack (simple pr{cision, rolled)#", $4, $5 }
/^linpackus/	{ print "Linpack (simple pr{cision, unrolled)#", $4, $5 }
/^linpackrd/	{ print "Linpack (double pr{cision, rolled)#", $4, $5 }
/^linpackud/	{ print "Linpack (double pr{cision, unrolled)#", $4, $5 }
/utah/		{
	t=$11+$13
	printf("Utah (temps d'\''ex{cution)# user=%ss, sys=%ss, u+s=%ss\n", $11, $13, t)
}
/outils/	{
	t=$11+$13
	printf("Outils (temps d'\''ex{cution)# user=%ss, sys=%ss, u+s=%ss\n", $11, $13, t) }
/pour byte/	{
	t=$11+$13
	printf("Byte (temps d'\''ex{cution)# user=%ss, sys=%ss, u+s=%ss\n",$11,$13,t) 
}
/^disk/		{
	print "Saxer (d{bit E/S disque)#", $8, "Ko/s"
}
/testc/		{
	t=$7+$8
	printf("Testc (temps d'\''ex{cution)# user=%ss, sys=%ss, u+s=%ss\n", $7, $8, t)
}
/^doducd/	{
	printf("Doduc (double pr{cision)# iterations=%s, temps=%ss, ratio=%s\n", $8, $12, $15)
}
/pour memoire/	{
	t=$11+$13
	printf("Bsd m{moire (temps d'\''ex{cution)# user=%ss, sys=%ss, u+s=%ss\n", $11, $13, t)
}
/appels/	{
	t=$11+$13
	printf("Bsd syscalls (temps d'\''ex{cution)# user=%ss, sys=%ss, u+s=%ss\n", $11, $13, t)
}
/pipes/		{
	t=$11+$13
	printf("Bsd pipes (temps d'\''ex{cution)# user=%ss, sys=%ss, u+s=%ss\n", $11, $13, t)
}
/fork/		{
	t=$11+$13
	printf("Bsd forks/execs (temps d'\''ex{cution)# user=%ss, sys=%ss, u+s=%ss\n", $11, $13, t)
}
/^Ecriture/	{ w[i++] =$2 }
/^Lecture/	{ r[j++] =$2 }
/^Copie/	{ c[k++] =$2 }
/^Elapsed/	{ 
	printf("Musbus (d{bit E/S disque pour 62 blocs)# ecr=%s Ko/s lect=%s Ko/s copie=%s Ko/s\n", w[0], r[0], c[0]) 
	printf("Musbus (d{bit E/S disque pour 125 blocs)# ecr=%s Ko/s lect=%s Ko/s copie=%s Ko/s\n", w[1], r[1], c[1])
	printf("Musbus (d{bit E/S disque pour 250 blocs)# ecr=%s Ko/s lect=%s Ko/s copie=%s Ko/s\n", w[2], r[2], c[2])
	printf("Musbus (d{bit E/S disque pour 500 blocs)# ecr=%s Ko/s lect=%s Ko/s copie=%s Ko/s\n", w[3], r[3], c[3])
	printf("Musbus (d{bit E/S disque pour 1000 blocs)# ecr=%s Ko/s lect=%s Ko/s copie=%s Ko/s\n", w[4], r[4], c[4])
	printf("Musbus temps r{el# %ss\n", $3) }
/^CPU/		{
	printf("Musbus temps cpu + syst}me# %ss\n", $3)
}
/^taille/	{
	print "Taille moyenne d'\''un ex{cutable#", $6/1000, "Ko"
}
/FIN/		{
	datefin = $10 " " $11 " " $12 " " $13 " " $14 " " $15 " " $16
}
/complet/	{
	printf("Temps total# %ss\n", $10)
}
/boucles/	{
	print "Nombre de boucles#", $12
}
/utilisateurs/	{
	print "Nombre moyen d'\''utilisateurs#", $9
}
/processus/	{
	print "Nombre moyen de processus#", $10
	printf("Date de fin# %s\n", datefin)
	printf(".TE\n")
}
END		{
	printf(".ce\n\\fBCOMMENTAIRES\\fP\n")
	printf(".S 10 11\n.sp .5\n\n")
	printf(".sp .5\n.ce\n.ft I\n\n")
	printf(".ft P\n.S 11 13\n.br\n.bp\n")
}
' >$1.txt
